﻿<?xml version="1.0" encoding="utf-8" ?>
<?xml-stylesheet type="text/css" href="Style.css" ?>
<xsl:stylesheet version="1.0" 
				xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
				xmlns:q1="http://schemas.xmlsoap.org/ws/2004/09/enumeration"
				xmlns:msxml="urn:schemas-microsoft-com:xslt"
				xmlns:mv="urn:my-scripts">
<xsl:output encoding="iso-8859-1" indent="yes" method="html" version="4.0" />
<xsl:param name="filter" />
<xsl:variable name="curnode" select="Results/ExportObject/ResourceManagementObject[ObjectIdentifier = $filter]/ResourceManagementAttributes/ResourceManagementAttribute" />
<xsl:variable name="SetFilter" select="mv:parse($curnode[AttributeName='Filter']/Value)" />
	<xsl:template match="/">
		<table style="font-family: Tahoma;font-size: 11px;border-top: #E6E6E6 1px solid;border-right: #E6E6E6 1px solid;border-left: #E6E6E6 1px solid;border-bottom: #E6E6E6 1px solid;" id="tdata">
			<xsl:call-template name="GeneralData" />
		</table>
	</xsl:template>
	<!--======================================================================================-->
	<!-- Template to display the general data                                                 -->
	<!--======================================================================================-->
	<xsl:template name="GeneralData">
		<tr>
			<td style="font-family: Tahoma;font-size: 11px;padding-top: 5px;padding-bottom: 5px;padding-left: 10px;padding-right: 10px;font-weight: bold;background: rgb(234,242,255);border-bottom: 1px solid rgb(120,172,255);">Set Configuration</td>
		</tr>
		<tr>
			<td>
				<table style="border: 0px;border-collapse:collapse;">
					<xsl:call-template name="DataItem">
						<xsl:with-param name="type">Name</xsl:with-param>
						<xsl:with-param name="value" select="$curnode[AttributeName='DisplayName']/Value" />
					</xsl:call-template>

					<xsl:call-template name="DataItem">
						<xsl:with-param name="type">Description</xsl:with-param>
						<xsl:with-param name="value" select="$curnode[AttributeName='Description']/Value" />
					</xsl:call-template>

					<xsl:call-template name="DataItem">
						<xsl:with-param name="type">Created Time</xsl:with-param>
						<xsl:with-param name="value" select="substring-before($curnode[AttributeName='CreatedTime']/Value, ' ')" />
					</xsl:call-template>


					<xsl:call-template name="DataItem">
						<xsl:with-param name="type">Filter</xsl:with-param>
						<xsl:with-param name="value" select="$SetFilter/q1:Filter" />
					</xsl:call-template>

					<xsl:variable name="hasmembers">
						<xsl:choose>
							<xsl:when test="count(ResourceManagementAttribute[AttributeName='ExplicitMember']) > 0" >
							yes
							</xsl:when>
							<xsl:otherwise>
                            no
							</xsl:otherwise>
						</xsl:choose>
					</xsl:variable>
					<xsl:call-template name="DataItem">
						<xsl:with-param name="type">Manually-managed Members</xsl:with-param>
						<xsl:with-param name="value" select="$hasmembers" />
					</xsl:call-template>
				</table>
			</td>
		</tr>
	</xsl:template>
	<!--=============================================================================================================================================================-->
	<!-- Template to display a data item                                                                                                                             -->
	<!--=============================================================================================================================================================-->
	<xsl:template name="DataItem">
		<xsl:param name="type" />
		<xsl:param name="value" />
		<tr>
			<td style="font-family: Tahoma;font-size: 11px;width:105px;text-align: left;padding-left: 10px;padding-right: 10px;padding-top: 2px;padding-bottom: 2px;font-weight: normal;white-space: nowrap;background-color:#E6E6E6;">
				<xsl:value-of select="$type" />
			</td>
			<td style="font-family: Tahoma;font-size: 11px;padding-left:5px;">
				<xsl:value-of select="$value" />
			</td>
		</tr>
	</xsl:template>
	<!--======================================================================================-->
	<!-- Template to add a table style                                                        -->
	<!--======================================================================================-->
	<xsl:template name="tablestyle">
		<xsl:attribute name="style">
			font-family:Tahoma;
			font-size:11px;
			border-top:1px RGB(212,208,200) solid;
			border-left:1px RGB(212,208,200) solid;
			border-right: 1px RGB(212,208,200) solid;
			border-bottom:1px RGB(212,208,200) solid;
			padding:0px;
		</xsl:attribute>
	</xsl:template>
	<!--======================================================================================-->
	<!-- Template to add a report head style                                                  -->
	<!--======================================================================================-->
	<xsl:template name="reportheadstyle">
		<xsl:attribute name="style">
			padding-top:10px;
			padding-bottom:10px;
			padding-left:10px;
			padding-right:10px;
			font-weight:bold;
			background:rgb(234,242,255);
			border-bottom:1px solid rgb(120,172,255)
		</xsl:attribute>
	</xsl:template>	
	<!--======================================================================================-->
	<!-- Template to add a head style                                                        -->
	<!--======================================================================================-->
	<xsl:template name="headstyle">
		<xsl:attribute name="style">
			background:#CCCCCC;
			border-right:#666666 1px solid;
			border-bottom:#666666 1px solid;
			padding-left:10px;
			padding-right:10px;
			font-weight:normal;
			white-space:nowrap;
		</xsl:attribute>
	</xsl:template>
	<!--======================================================================================-->
	<!-- Template to add a display name style                                                 -->
	<!--======================================================================================-->
	<xsl:template name="dspnstyle">
		<xsl:attribute name="style">
			padding-left:10px;
			padding-right:10px;
			font-weight:normal;
			white-space:nowrap;
		</xsl:attribute>
	</xsl:template>
	<!--======================================================================================-->
	<!-- Template to add a filter style                                                       -->
	<!--======================================================================================-->
	<xsl:template name="filterstyle">
		<xsl:attribute name="style">
			padding-left:10px;
			padding-right:10px;
			font-weight:normal;
		</xsl:attribute>
	</xsl:template>
	<!--======================================================================================-->
	<!-- Template to add a center cell                                                        -->
	<!--======================================================================================-->
	<xsl:template name="centercell">
		<xsl:attribute name="style">
			padding-left:10px;
			padding-right:10px;
			white-space:nowrap;
			text-align:center;
			font-weight:normal;"
		</xsl:attribute>
	</xsl:template>
	<!--===================================================================================================================================-->
	<!-- Script to convert XML Text into XML Node List                                                                                     -->
	<!--===================================================================================================================================-->
	<msxml:script language="CSharp" implements-prefix="mv">
		<msxml:using namespace="System.IO" />
		public XPathNodeIterator parse(string data)
		{
		String xmlString = "&lt;root&gt;" + data + "&lt;/root&gt;";
		StringReader stringReader = new StringReader(xmlString);

		XPathDocument xPathDocument = new XPathDocument(stringReader);
		XPathNavigator xPathNavigator = xPathDocument.CreateNavigator();

		return xPathNavigator.Select("root");
		}
	</msxml:script>
</xsl:stylesheet>
